/*
 * Copyright (c) 2010 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution  and  use  in  source  and binary  forms,  with  or  without
 * modification, are permitted provided that the following conditions are met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice and this list of conditions.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice and  this list of  conditions in the  documentation and/or
 *      other materials provided with the distribution.
 *
 * THE SOFTWARE  IS PROVIDED "AS IS"  AND THE AUTHOR  DISCLAIMS ALL WARRANTIES
 * WITH  REGARD   TO  THIS  SOFTWARE  INCLUDING  ALL   IMPLIED  WARRANTIES  OF
 * MERCHANTABILITY AND  FITNESS.  IN NO EVENT  SHALL THE AUTHOR  BE LIABLE FOR
 * ANY  SPECIAL, DIRECT,  INDIRECT, OR  CONSEQUENTIAL DAMAGES  OR  ANY DAMAGES
 * WHATSOEVER  RESULTING FROM  LOSS OF  USE, DATA  OR PROFITS,  WHETHER  IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR  OTHER TORTIOUS ACTION, ARISING OUT OF OR
 * IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef _VELODYNE_CLIENT_H
#define _VELODYNE_CLIENT_H

#include <pomStruct.h>

/***********************************************************************
 *
 * Exported poster structure
 *
 ***********************************************************************/

#define VELODYNE_NB_LINES	(750)
#define VELODYNE_NB_COLUMNS	(384)
/* These sizes are for now hardcoded (the number or packets produced by the
   sensor varies between 720 and 733 when it turns at 5Hz) */

typedef enum VELODYNE_3DPOINT_STATUS {
	VELODYNE_BAD_3DPOINT,
	VELODYNE_GOOD_3DPOINT
} VELODYNE_3DPOINT_STATUS;

typedef struct velodyne3DPoint {
  short				intensity;
  float				coordinates[3];
  VELODYNE_3DPOINT_STATUS	status;
} velodyne3DPoint;

typedef struct velodyne3DImage {
  POM_SENSOR_POS	position; /* The pom-position at the time the
				     acquisition request was made */
  int			nbLines; /* The number of lines actually updated (each
				    line corresponds to a Velodyne packet) */
  velodyne3DPoint	points[VELODYNE_NB_LINES*VELODYNE_NB_COLUMNS];
} velodyne3DImage;

#endif /* _VELODYNE_CLIENT_H */
